<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Pages';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 4 )  {
  debut($mysqli,'Pages','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Modification des pages',$message,4,'pages');
echo <<<FIN

  <a class="icon-aide general" data-id="page" title="Aide pour les modifications des pages"></a>
  <a class="icon-ajoute general" data-id="ajoute" title="Ajouter une nouvelle page"></a>

FIN;
$select_protection = '
          <option value="0">Visible de tous</option>
          <option value="1">Visible pour les connectés</option>
          <option value="2">Visible pour les élèves, colleurs, profs</option>
          <option value="3">Visible pour les colleurs et les profs</option>
          <option value="4">Visible pour les profs uniquement</option>
          <option value="5">Non visible</option>';


// Récupération des matières
$select_matieres = '<option value="0">Pas de matière associée</option>';
$resultat = $mysqli->query("SELECT id, nom FROM matieres WHERE FIND_IN_SET(id,'${_SESSION['matieres']}') ORDER BY ordre");
while ( $r = $resultat->fetch_assoc() )
  $select_matieres .= "<option value=\"${r['id']}\">${r['nom']}</option>";
$resultat->free();

// Récupération des pages
$resultat = $mysqli->query("SELECT IFNULL(m.id,0) AS id, m.nom, MAX(p.ordre) AS max
                            FROM pages AS p LEFT JOIN matieres AS m ON p.mat = m.id
                            WHERE FIND_IN_SET(p.mat,'${_SESSION['matieres']}') GROUP BY m.id ORDER BY m.ordre");
while ( $m = $resultat->fetch_assoc() )  {
  if ( $m['id'] )
    echo "\n  <h3>${m['nom']}</h3>\n";
  $resultat1 = $mysqli->query("SELECT p.id, p.ordre, p.cle, p.nom, p.mat, p.titre, p.bandeau, p.protection, COUNT(i.id) AS n
                              FROM pages AS p LEFT JOIN infos AS i ON i.page = p.id WHERE p.mat = ${m['id']} GROUP BY p.id ORDER BY p.ordre");
  while ( $r = $resultat1->fetch_assoc() )  {
    $id = $r['id'];
    $monte = ( ( $r['ordre'] == 1 ) || ( !$m['id'] && ( $r['ordre'] == 2 ) ) ) ? ' style="display:none;"' : '';
    $descend = ( ( $r['ordre'] == $m['max'] ) || ( $r['id'] == 1 ) ) ? ' style="display:none;"' : '';
    $sel_matiere = str_replace("\"${m['id']}\"","\"${m['id']}\" selected",$select_matieres);
    $sel_protection = str_replace("\"${r['protection']}\"","\"${r['protection']}\" selected",$select_protection);
    $suppr = ( $r['id'] > 1 ) ? "\n    <a class=\"icon-supprime\" title=\"Supprimer cette page\"></a>" : '';
    $nom = ( $m['id'] ) ? "${m['nom']}/${r['nom']}" : $r['nom'];
    if ( $r['id'] > 1 )  {
      $suppr = "\n    <a class=\"icon-supprime\" title=\"Supprimer cette page\"></a>";
      str_replace("\"${m['id']}\"","\"${m['id']}\" selected",$select_matieres);
      $sel_matiere = <<<FIN

      <p class="ligne"><label for="matiere$id">Matière&nbsp;: </label>
        <select id="matiere$id" name="matiere">$sel_matiere</select>
      </p>
FIN;
      $span = '';
    }
    else  {
      $suppr = $sel_matiere = '';
      // Pour obtenir le bon comportement du script js lors après les montées/descentes
      $span = '<span></span>';
    }
    $supprinfos = ( $r['n'] ) ? "\n      <input type=\"button\" class=\"ligne supprmultiple\" data-id=\"pages|$id|infos\" value=\"Supprimer les ${r['n']} informations de la page\">" : '';
    echo <<<FIN

  <article data-id="pages|$id">
    <a class="icon-monte"$monte title="Déplacer cette matière vers le haut"></a>
    <a class="icon-descend"$descend title="Déplacer cette matière vers le bas"></a>$suppr
    <form>
      <a class="icon-ok" title="Valider les modifications"></a>
      <h3 class="edition">$nom</h3>
      <p class="ligne"><label for="titre$id">Titre&nbsp;: </label><input type="text" id="titre$id" name="titre" value="${r['titre']}" size="50" data-placeholder="Ex: «&nbsp;Informations en [matière]&nbsp;», «&nbsp;À propos du TIPE&nbsp;»"></p>
      <p class="ligne"><label for="nom$id">Nom dans le menu&nbsp;: </label><input type="text" id="nom$id" name="nom" value="${r['nom']}" size="50" data-placeholder="Pas trop long. Ex: «&nbsp;Informations&nbsp;», «&nbsp;Informations TIPE&nbsp;»"></p>
      <p class="ligne"><label for="cle$id">Clé dans l'adresse&nbsp;: </label><input type="text" id="cle$id" name="cle" value="${r['cle']}" size="30" data-placeholder="En minuscules et sans espace. Ex: «&nbsp;infos&nbsp;», «&nbsp;tipe&nbsp;»"></p>$sel_matiere
      <p class="ligne"><label for="protection$id">Accès&nbsp;: </label>
        <select id="protection$id" name="protection">$sel_protection
        </select>
      </p>
      <p class="ligne"><label for="bandeau$id">Texte de début&nbsp;:</label></p>
      <textarea id="bandeau$id" name="bandeau" rows="2" cols="100" data-placeholder="Texte qui s'affichera au début de la page">${r['bandeau']}</textarea>$supprinfos
    </form>
  </article>$span

FIN;
  }
  $resultat1->free();
}
$resultat->free();

// Aide et formulaire d'ajout
?>

  <form id="form-ajoute">
    <h3 class="edition">Ajouter une nouvelle page</h3>
    <div>
      <input type="text" class="ligne"  id="nom" name="nom" value="" size="50" data-placeholder="Nom pour le menu. Pas trop long. Ex: «&nbsp;Informations&nbsp;», «&nbsp;Informations TIPE&nbsp;»">
      <input type="text" class="ligne" id="cle" name="cle" value="" size="30" data-placeholder="Clé pour l''adresse web. En minuscules et sans espace. Ex: «&nbsp;infos&nbsp;», «&nbsp;tipe&nbsp;»">
      <input type="text" class="ligne" id="titre" name="titre" value="" size="50" data-placeholder="Titre. Ex: «&nbsp;Informations en [matière]&nbsp;», «&nbsp;À propos du TIPE&nbsp;»">
      <p class="ligne"><label for="matiere$id">Matière&nbsp;: </label>
        <select id="matiere" name="matiere">
          <?php echo $select_matieres; ?>
        </select>
      </p>
      <p class="ligne"><label for="protection">Accès&nbsp;: </label>
        <select id="protection" name="protection"><?php echo $select_protection; ?>
        </select>
      </p>
      <p class="ligne"><label for="bandeau">Texte de début&nbsp;:</label></p>
      <textarea id="bandeau" name="bandeau" rows="2" cols="100" data-placeholder="Texte qui s'affichera au début de la page"></textarea>
      <input type="hidden" name="table" value="pages">
    </div>
  </form>

  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici d'ajouter, de modifier et de supprimer les pages d'informations de ce Cahier de Prépa.</p>
    <p>Chaque page peut être sans matière associée ou non. Sans matière associée, elle sera affichée tout en haut du menu, directement sous les icônes. Avec une matière associée, elle sera affichée dans le menu sous le titre de la matière. Une page apparaît toujours dans le menu des visiteurs connectés en tant que professeur, pour pouvoir être éditée. Pour les autres visiteurs (non connecté ou invité/élève/colleur), elle n'apparaît que si elle est contient au moins une information.</p>
    <p>La première page sans matière associée est la page d'accueil du Cahier de Prépa&nbsp;: il est donc impossible de la supprimer ou de la déplacer.</p>
    <p>Pour toutes les autres pages, il est possible de les supprimer en cliquant sur le bouton <span class="icon-supprime"></span> (une confirmation sera demandée). Si cela est possible, les pages peuvent être déplacées les unes par rapport aux autres dans le menu, à l'aide des boutons <span class="icon-monte"></span> et <span class="icon-descend"></span>.</p>
    <p>Seules les pages sans matière associée ou dont la matière associée est aussi associée à votre compte sont modifiables. Vous pouvez modifier les associations des matières à votre compte dans la page de <a href="matieres">gestion des matières</a>.</p>
    <h4>Préférences associées à chaque page</h4>
    <p>Pour chaque page, vous pouvez modifier&nbsp;:</p>
    <ul>
      <li>le <em>titre</em> qui sera affiché en haut de page et dans la barre de titre du navigateur. Par exemple, «&nbsp;À propos du TIPE&nbsp;».</li>
      <li>le <em>nom dans le menu</em> qui est affiché dans le menu en tant que lien vers la page. Il est préférable qu'il rentre sur une ligne, il faut donc le choisir assez court. Par exemple, «&nbsp;Informations TIPE&nbsp;».</li>
      <li>la <em>clé dans l'adresse</em> qui est un mot-clé utilisé uniquement dans l'adresse de la page. Par convention, il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;tipe&nbsp;». La clé doit obligatoirement être unique (deux pages ne peuvent pas avoir la même clé).</li>
      <li>la <em>matière</em> associée qui conditionne la place du lien dans le menu de la partie publique. Vous ne pouvez associer à une nouvelle page qu'une matière déjà associée à votre compte. Vous pouvez modifier les associations des matières à votre compte dans la page de <a href="matieres">gestion des matières</a>.</li>
      <li>l'<em>accès</em> à la page (voir ci-dessous).</li>
      <li>le <em>texte de début</em> qui sera affiché au-dessus des informations de la page. Il s'agit d'une ou deux phrases maximum. Il n'est affiché que si la page contient des informations. Cette case peut être laissée vide.</li>
    </ul>
    <p>L'<em>accès</em> à chaque page peut être choisi parmi six possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: accessible de tout visiteur, sans identification.</li>
      <li><em>Visible pour les connectés</em>&nbsp;: accessible de tout utilisateur mais uniquement après identification (utilisateurs de type invité, élève, colleur ou professeur). Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type élève, colleur ou professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type colleur ou professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Non visible</em>&nbsp;: entièrement invisible pour les utilisateurs autres que les professeurs (éventuellement associés à la matière dont la page peut dépendre). La différence avec le choix précédent est que cette page n'apparaît plus du tout dans le menu pour ceux qui ne la voient pas.</li>
    </ul>
    <p>Hormis le dernier choix, le lien dans le menu apparaîtra pour tout visiteur (identifié ou non). Le niveau de protection est indiqué dans le titre par une icône de type <span class="icon-lock1"></span> où le numéro correspond au niveau de protection à côté du titre, lorsque vous allez sur la page concernée connecté en tant que professeur.</p>
    <p>Le titre de la première page a un statut spécial&nbsp;: c'est le titre du Cahier de Prépa. Il est donc repris à plusieurs endroits (titre dans la barre de titre du navigateur, titre dans le flux RSS). Le <em>nom dans le menu</em> de cette page est par contre peu important car affiché uniquement lorsque la souris survole l'icône <span class="icon-accueil"></span>.</p>
    <h4>Suppression d'une page ou de ses informations</h4>
    <p>La suppression d'une page entraîne automatiquement la suppression de toutes les informations qui y étaient inscrites.</p>
    <p>Il est aussi possible de supprimer toutes les informations d'une page (sans supprimer la page elle-même) en cliquant sur le bouton correspondant. Celui-ci n'apparaît pas pour les pages vides.</p>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de créer une nouvelle page d'informations. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-ferme"></span>.</p>
    <p>Il est possible de définir pour cette page&nbsp;:</p>
    <ul>
      <li>le <em>titre</em> qui sera affiché en haut de page et dans la barre de titre du navigateur. Par exemple, «&nbsp;À propos du TIPE&nbsp;».</li>
      <li>le <em>nom dans le menu</em> qui est affiché dans le menu en tant que lien vers la page. Il est préférable qu'il rentre sur une ligne, il faut donc le choisir assez court. Par exemple, «&nbsp;Informations TIPE&nbsp;».</li>
      <li>la <em>clé dans l'adresse</em> qui est un mot-clé utilisé uniquement dans l'adresse de la page. Par convention, il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;tipe&nbsp;». La clé doit obligatoirement être unique (deux pages ne peuvent pas avoir la même clé).</li>
      <li>la <em>matière</em> associée qui conditionne la place du lien dans le menu de la partie publique. Vous ne pouvez associer à une nouvelle page qu'une matière déjà associée à votre compte. Vous pouvez modifier les associations des matières à votre compte dans la page de <a href="matieres">gestion des matières</a>.</li>
      <li>l'<em>accès</em> à la page (voir ci-dessous).</li>
      <li>le <em>texte de début</em> qui sera affiché au-dessus des informations de la page. Il s'agit d'une ou deux phrases maximum. Il n'est affiché que si la page contient des informations. Cette case peut être laissée vide.</li>
    </ul>
    <p>L'<em>accès</em> à la page peut être choisi parmi six possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: accessible de tout visiteur, sans identification.</li>
      <li><em>Visible pour les connectés</em>&nbsp;: accessible de tout utilisateur mais uniquement après identification (utilisateurs de type invité, élève, colleur ou professeur). Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type élève, colleur ou professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type colleur ou professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Non visible</em>&nbsp;: entièrement invisible pour les utilisateurs autres que les professeurs (éventuellement associés à la matière dont la page peut dépendre). La différence avec le choix précédent est que cette page n'apparaît plus du tout dans le menu pour ceux qui ne la voient pas.</li>
    </ul>
    <p>Hormis le dernier choix, le lien dans le menu apparaîtra pour tout visiteur (identifié ou non). Le niveau de protection est indiqué dans le titre par une icône de type <span class="icon-lock1"></span> où le numéro correspond au niveau de protection à côté du titre, lorsque vous allez sur la page concernée connecté en tant que professeur.</p>
    <p>La page sera automatiquement positionnée en dernière place, éventuellement au sein de la matière choisie. Il est ensuite possible de la déplacer parmi les autres pages à l'aide des boutons <span class="icon-monte"></span> et <span class="icon-descend"></span>.</p>   
  </div>

  <p id="log"></p>
  
  <script type="text/javascript">
$( function() {
  // Défaut sur le bandeau
  $('[name="bandeau"]').placeholder();
  // Envoi par appui sur Entrée
  $('input,select').on('keypress',function (e) {
    if ( e.which == 13 )
      $(this).parent().parent().children('a.icon-ok').click();
  });
});
  </script>
<?php

$mysqli->close();
fin(true);
?>
