<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Compte demandés en attente de validation de l'équipe pédagogique :
// @ devant mail (pour empêcher la récupération de mdp par mail), * devant mdp
// Compte proposés en attente de réponse de l'utilisateur : mdp = '*'
// => Pour les différentier, utiliser la longueur du mdp (1, 40, 41).

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Modification des utilisateurs';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 4 )  {
  debut($mysqli,'Modification des utilisateurs','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Modification des utilisateurs',$message,4,'utilisateurs');
echo <<<FIN

  <a class="icon-aide general" data-id="page" title="Aide pour les modifications des utilisateurs"></a>
  <a class="icon-prefs general" data-id="prefs" title="Modifier les réglages de la gestion des comptes"></a>
  <a class="icon-ajoute general" data-id="ajoute" title="Ajouter de nouveaux utilisateurs"></a>

  <article>
    <h3>Liste des utilisateurs</h3>
    <table>
      <tbody>

FIN;

$autorisations = array(1=>'Invité',2=>'Élève',3=>'Colleur',4=>'Professeur');

// Récupération des demandes à valider
$resultat = $mysqli->query('SELECT id, IF(LENGTH(mail),SUBSTR(mail,2),"Pas d\'adresse") AS mail, autorisation, CONCAT( nom, \' \', prenom ) AS nom
                            FROM utilisateurs WHERE LENGTH(mdp)=41 ORDER BY IF(LENGTH(nom),CONCAT(nom,prenom),login)');
if ( $n = $resultat->num_rows )  {
  $n = ( $n > 1 ) ? "$n comptes" : "1 compte";
  echo "        <tr><th colspan=\"5\">En attente de validation ($n)</th></tr>\n";
  while ( $r = $resultat->fetch_assoc() )
    echo "        <tr><td colspan=\"4\">${r['nom']} - ${r['mail']} - ".$autorisations[$r['autorisation']]."</td><td data-id=\"utilisateurs|${r['id']}\"><a class=\"icon-supprime\" title=\"Supprimer ce compte\"> <a class=\"icon-ajoute\" title=\"Valider ce compte\"></a></td></tr>\n";
  $resultat->free();
}

// Récupération des invitations non répondues
$resultat = $mysqli->query('SELECT id, IF(LENGTH(mail),mail,"Pas d\'adresse") AS mail, autorisation, CONCAT( nom, \' \', prenom ) AS nom
                            FROM utilisateurs WHERE LENGTH(mdp)=1 ORDER BY IF(LENGTH(nom),CONCAT(nom,prenom),login)');
if ( $n = $resultat->num_rows )  {
  $n = ( $n > 1 ) ? "$n comptes" : "1 compte";
  echo "        <tr><th colspan=\"5\">Invitations envoyées ($n)</th></tr>\n";
  while ( $r = $resultat->fetch_assoc() )
    echo "        <tr><td colspan=\"4\">${r['nom']} - ${r['mail']} - ".$autorisations[$r['autorisation']]."</td><td data-id=\"utilisateurs|${r['id']}\"><a class=\"icon-supprime\" title=\"Supprimer ce compte\"></a></td></tr>\n";
  $resultat->free();
}

// Décompte total des utilisateurs (comptes validés) en fonction de leur type
$resultat = $mysqli->query('SELECT autorisation, COUNT(id) AS n FROM utilisateurs WHERE LENGTH(mdp)=40 GROUP BY autorisation ORDER BY autorisation DESC');
$n = array();
while ( $r = $resultat->fetch_assoc() )
  $n[$r['autorisation']] = ( $r['n'] > 1 ) ? "${r['n']} comptes" : "${r['n']} compte";
$resultat->free();

// Récupération des utilisateurs
$resultat = $mysqli->query('SELECT id, nom, prenom, login, mail, autorisation
                            FROM utilisateurs WHERE LENGTH(mdp)=40 ORDER BY autorisation DESC, IF(LENGTH(nom),CONCAT(nom,prenom),login)');
$a = 0;
while ( $r = $resultat->fetch_assoc() )  {
  if ( $a != $r['autorisation'] )  {
    $a = $r['autorisation'];
    switch ( $a )  {
      case 1 : $t = 'Invités'; break;
      case 2 : $t = 'Élèves'; break;
      case 3 : $t = 'Colleurs'; break;
      case 4 : $t = 'Professeurs'; break;
    }
    echo <<<FIN
        <tr><th colspan="5">$t (${n[$a]})</th></tr>
        <tr><th>Nom</th><th>Prénom</th><th>Identifiant</th><th>Adresse électronique</th><th></th></tr>

FIN;
  }
  if ( $a > 1 )
    echo "        <tr><td class=\"editable\" data-id=\"utilisateurs|nom|${r['id']}\">${r['nom']}</td><td class=\"editable\" data-id=\"utilisateurs|prenom|${r['id']}\">${r['prenom']}</td><td>${r['login']}</td><td class=\"editable\" data-id=\"utilisateurs|mail|${r['id']}\">${r['mail']}</td><td data-id=\"utilisateurs|${r['id']}\"><a class=\"icon-supprime\" title=\"Supprimer ce compte\"></a></td></tr>\n";
  else
    echo "        <tr><td></td><td></td><td>${r['login']}</td><td></td><td data-id=\"utilisateurs|${r['id']}\"><a class=\"icon-supprime\" title=\"Supprimer ce compte\"></a></td></tr>\n";
}
?>
      </tbody>
    </table>
  </article>

<?php
// Récupération des matières
$resultat = $mysqli->query('SELECT id, nom FROM matieres');
$select_matieres = '';
while ( $r = $resultat->fetch_assoc() )
  $select_matieres .= "\n          <option value=\"${r['id']}\">${r['nom']}</option>";
$resultat->free();

// Récupération du réglage "création impossible"
$resultat = $mysqli->query('SELECT id FROM utilisateurs WHERE LENGTH(mdp) = 0');
if ( $creationinterdite = $resultat->num_rows )
  $resultat->free();

// Aide et formulaire d'ajout
?>
  <form id="form-ajoute">
    <h3 class="edition">Ajouter de nouveaux utilisateurs</h3>
    <p class="ligne"><label for="autorisation">Type de comptes&nbsp;:</label>
      <select name="autorisation" id="autorisation">
        <option value="1">Invités</option>
        <option value="2" selected>Élèves</option>
        <option value="3">Colleurs</option>
        <option value="4">Professeurs</option>
      </select>
    </p>
    <p class="ligne"><label for="matiere">Matière&nbsp;:</label>
      <select name="matiere" id="matiere">
        <option value="0">Toutes matières</option><?php echo $select_matieres; ?>

      </select>
    </p>
    <p class="ligne"><label for="utilisateurs">Comptes à créer&nbsp;:</label></p>
    <p>Écrire ci-dessous les nouveaux utilisateurs&nbsp;:</p>
    <ul>
      <li>Un utilisateur par ligne</li>
      <li>Uniquement des utilisateurs de même type à chaque envoi</li>
      <li>Pour chaque utilisateur de type élève, colleur ou professeur, deux possibilités&nbsp;:
        <ul style="margin: 0;">
          <li>3 valeurs séparées par des virgules&nbsp;: nom, prénom, adresse électronique</li>
          <li>3 valeurs séparées par des points-virgules&nbsp;: nom, prénom, mot de passe</li>
        </ul>
        Dans le premier cas, un courriel sera envoyé à chaque utilisateur avec un lien pour générer le mot de passe. Dans le second cas, ce sera à vous de communiquer les mots de passe.
      </li>
      <li>Pour chaque compte invité, 2 valeurs séparées par des virgules&nbsp;: identifiant, mot de passe</li>
    </ul>
    <textarea id="utilisateurs" name="utilisateurs" rows="10" cols="100" data-placeholder="Comptes élèves ou colleurs ou professeurs :<br>Nom1,Prénom1,Mail1<br>Nom2,Prénom2,Mail2<br>...<br>Comptes invités :<br>Identifiant1,Motdepasse1<br>Identifiant2,Motdepasse2<br>..."></textarea>
    <input type="hidden" name="table" value="utilisateurs">
  </form>

  <form id="form-prefs">
    <h3 class="edition">Réglages de la gestion des comptes</h3>
    <p class="ligne"><label for="autoriser">Autoriser les demandes de création de comptes&nbsp;: </label>
      <input type="checkbox" id="autoriser" name="autoriser"<?php echo ( $creationinterdite ) ? '' : ' checked'; ?>>
    </p>
    <input type="hidden" name="creation" value="1">
    <input type="hidden" name="table" value="utilisateurs">
    <p class="ligne">Pour modifier les associations entre utilisateurs et matières, il faut vous rendre sur la page de <a href="matieres">gestion des matières</a>.</p>
  </form>
  
  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici d'ajouter, de modifier et de supprimer des utilisateurs pouvant se connecter à ce Cahier de Prépa.</p>
    <p>Les associations entre les utilisateurs et les matières sont à régler dans la page de <a href="matieres">gestion des matières</a>.</p>
    <p>Les deux boutons généraux permettent de&nbsp;:</p>
    <ul>
      <li><span class="icon-ajoute"></span>&nbsp;: ouvrir un formulaire pour ajouter de nouveaux utilisateurs.</li>
      <li><span class="icon-prefs"></span>&nbsp;: ouvrir un formulaire pour autoriser ou interdire les demandes de création de compte.</li>
    </ul>
    <h4>Tableau récapitulatif</h4>
    <p>Le tableau récapitulatif ci-dessous présente tous les utilisateurs existants, ordonnés par type puis par ordre alphabétique.</p>
    <p>Les noms, prénoms et adresses électroniques des utilisateurs existants sont directement modifiables en cliquant sur le bouton <span class="icon-edite"></span> et en validant avec le bouton <span class="icon-ok"></span> qui apparaît alors.</p>
    <p>La modification d'une adresse électronique entraîne l'envoi automatique d'un courriel, à l'adresse modifiée uniquement (pas à l'ancienne adresse). Vous ne serez pas en copie de ce courriel.</p>
    <p>Les identifiants ne sont pas modifiables ici&nbsp;: l'utilisateur concerné ne pourrait plus se connecter. Chaque utilisateur (y compris vous) peut modifier son propre identifiant sur la page de ses <a href="prefs">préférences</a>.</p>
    <p>Chaque utilisateur peut être supprimé à l'aide du bouton <span class="icon-supprime"></span> (une confirmation sera demandée). Attention, si vous supprimez votre compte, vous serez rapidement déconnecté et ne pourrez plus vous connecter à nouveau.</p>
    <p>Attention&nbsp;: lors de la suppression d'un utilisateur (élève, colleur, professeur), les colles le concernant sont automatiquement supprimées. Ne supprimez pas un compte pour le recréer, modifiez-le directement.</p>
    <p>Il n'est pas possible de changer le type d'un utilisateur (transformer un élève en colleur, etc.).</p>
    <h4>Types d'utilisateurs</h4>
    <p>Il existe quatre types d'utilisateurs&nbsp;:</p>
    <ul>
      <li>Les <em>professeurs</em> peuvent modifier tout ce qui est réglable dans ce Cahier de Prépa&nbsp;: pages d'informations et informations générales, utilisateurs, groupes d'élèves, matières, planning annuel. Tous les professeurs ont les mêmes droits sur ces catégories (il n'y a pas d'&laquo;&nbsp;administrateur&nbsp;&raquo;). Ils peuvent être associés ou non à une ou plusieurs matières, et pouvoir alors modifier ce qui concerne spécifiquement ces matières&nbsp;: programmes de colles, cahier de texte, documents, notes de colles. Ils peuvent voir l'ensemble des notes de colles mises dans les matières associées, et les récupérer sous forme de fichier xls. Les professeurs peuvent aussi envoyer des courriels à tous les autres utilisateurs.</li>
      <li>Les <em>colleurs</em> peuvent être associés ou non à une ou plusieurs matières (ils ne peuvent pas modifier leur liste des matières associées). Ils peuvent voir les contenus associés à ces matières et les contenus généraux, sauf les contenus protégés visibles seulement par les professeurs. Ils peuvent mettre des notes dans ces matières et voir leurs notes uniquement. Ils peuvent modifier leur identité. Ils peuvent aussi envoyer des courriels à tous les autres utilisateurs.</li>
      <li>Les <em>élèves</em> peuvent être associés ou non à une ou plusieurs matières (ils ne peuvent pas modifier leur liste des matières associées). Ils peuvent voir les contenus associés à ces matières et les contenus généraux, sauf les contenus protégés visibles seulement par les colleurs ou les professeurs. Ils peuvent voir leurs notes de colles. Ils peuvent modifier leur identité. Ils ne peuvent pas envoyer de courriels.</li>
      <li>Les <em>invités</em> sont des comptes prévus pour être éventuellement partagés entre plusieurs personnes. Une fois connecté, il est impossible de changer les paramètres du compte (identifiant, mot de passe, matières associées). Les invités peuvent voir les contenus associés à leurs matières et les contenus généraux marqués comme visibles sans autorisation ou pour tous les connectés.</li>
    </ul>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de créer de nouveaux comptes utilisateurs. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-ferme"></span>.</p>
    <p>Il est possible de créer simultanément autant de comptes que l'on le souhaite, mais tous les comptes créés simultanément doivent correspondre à un même type d'utilisateurs (invités, élèves, colleurs, professeurs).</p>
    <p>Il est possible de restreindre les utilisateurs à une seule matière&nbsp;: ils ne pourront alors consulter que les contenus généraux et ceux de cette matière&nbsp;; pour les colleurs, ils pourront aussi mettre des notes, uniquement dans cette matière&nbsp;; pour les professeurs, ils pourront aussi modifier les propriétés générales du Cahier de Prépa et les contenus de cette matière.</p>
    <p>L'association à une matière n'est pas définitive&nbsp;: il est possible de modifier (ajouter ou supprimer) les associations entre matières et utilisateurs à tout moment et pour tous les utilisateurs, sur la page de <a href="matieres">gestion des matières</a>. On peut alors notamment associer une deuxième matière à un utilisateur créé et associé à une seule.</p>
    <p>Les comptes utilisateurs à créer doivent être écrits à raison d'un compte par ligne.</p>
    <p>À chaque ligne, si les utilisateurs sont de type élèves, colleurs ou professeurs, il y a deux syntaxes possibles&nbsp;:</p>
    <ul>
      <li>3 valeurs séparées par des virgules&nbsp;: nom, prénom, adresse électronique. Un courriel d'invitation sera alors envoyé à l'adresse indiquée, avec un lien permettant de générer le mot de passe. L'utilisateur apparaîtra dans une case &laquo;&nbsp;invitations&nbsp;&raquo; dans le tableau récapitulatif. Attention, il ne sera pas possible de modifier cet utilisateur, de lui envoyer un mail ou de lui attribuer une note tant qu'il n'aura pas répondu à l'invitation. Il sera cependant possible de le supprimer.</li>
      <li>3 valeurs séparées par des points-virgules&nbsp;: nom, prénom, mot de passe. Le compte est alors immédiatement créé et directement utilisable (pour lui envoyer un mail ou de lui attribuer une note par exemple). Il faudra par contre communiquer séparément à la personne concernée son identifiant et son mot de passe.</li>
    </ul>
    <p>À chaque ligne, si les utilisateurs sont de type invités, il faut écrire l'identifiant et le mot de passe séparés par une virgule. À vous de communiquer ces données aux personnes à qui vous souhaiter donner l'accès.</p>
    <h4>Types d'utilisateurs</h4>
    <p>Il existe quatre types d'utilisateurs&nbsp;:</p>
    <ul>
      <li>Les <em>professeurs</em> peuvent modifier tout ce qui est réglable dans ce Cahier de Prépa&nbsp;: pages d'informations et informations générales, utilisateurs, groupes d'élèves, matières, planning annuel. Tous les professeurs ont les mêmes droits sur ces catégories (il n'y a pas d'&laquo;&nbsp;administrateur&nbsp;&raquo;). Ils peuvent être associés ou non à une ou plusieurs matières, et pouvoir alors modifier ce qui concerne spécifiquement ces matières&nbsp;: programmes de colles, cahier de texte, documents, notes de colles. Ils peuvent voir l'ensemble des notes de colles mises dans les matières associées, et les récupérer sous forme de fichier xls. Les professeurs peuvent aussi envoyer des courriels à tous les autres utilisateurs.</li>
      <li>Les <em>colleurs</em> peuvent être associés ou non à une ou plusieurs matières (ils ne peuvent pas modifier leur liste des matières associées). Ils peuvent voir les contenus associés à ces matières et les contenus généraux, sauf les contenus protégés visibles seulement par les professeurs. Ils peuvent mettre des notes dans ces matières et voir leurs notes uniquement. Ils peuvent modifier leur identité. Ils peuvent aussi envoyer des courriels à tous les autres utilisateurs.</li>
      <li>Les <em>élèves</em> peuvent être associés ou non à une ou plusieurs matières (ils ne peuvent pas modifier leur liste des matières associées). Ils peuvent voir les contenus associés à ces matières et les contenus généraux, sauf les contenus protégés visibles seulement par les colleurs ou les professeurs. Ils peuvent voir leurs notes de colles. Ils peuvent modifier leur identité. Ils ne peuvent pas envoyer de courriels.</li>
      <li>Les <em>invités</em> sont des comptes prévus pour être éventuellement partagés entre plusieurs personnes. Une fois connecté, il est impossible de changer les paramètres du compte (identifiant, mot de passe, matières associées). Les invités peuvent voir les contenus associés à leurs matières et les contenus généraux marqués comme visibles sans autorisation ou pour tous les connectés.</li>
    </ul>
  </div>
  
  <div id="aide-prefs">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet d'autoriser ou d'interdire les demandes de création de compte. Ces demandes peuvent être réalisées par des utilisateurs non connectés, ayant cliqué sur le bouton <span class="icon-connexion"></span>, puis &laquo;&nbsp;Créer un compte&nbsp;&raquo;. Les demandes existantes sont placées en attente de validation sur cette page. Si tous les élèves et colleurs attendus ont leur compte, il peut être utile de décocher cette case pour éviter les demandes imprévues.</p>
    <p>Ce formulaire sera validé par un clic sur <span class="icon-ok"></span>, et abandonné par un clic sur <span class="icon-ferme"></span>.</p>
  </div>

  <p id="log"></p>
<?php

$mysqli->close();
fin(true);
?>
